Page MenuHome

Changing Scale on Object doesn't affect Rigid Body
Closed, ResolvedPublic

Description

System Information
Operating system: Darwin-17.7.0-x86_64-i386-64bit 64 Bits
Graphics card: NVIDIA GeForce GT 750M OpenGL Engine NVIDIA Corporation 4.1 NVIDIA-10.32.0 355.11.10.10.40.102

Blender Version
Broken: version: 2.80 (sub 69), branch: blender2.7, commit date: 2019-05-18 17:13, hash: rB1fce0460d522
Worked: (optional)

Short description of error
If you animate the scale of an object, the RigidBody does not update.

Exact steps for others to reproduce the error
I've hit a wall with a specific type of animation.

  1. A group of objects fall with physics into a pile.
  2. A subset then scale down to 0
  3. The remaining continue to lower down

Animating the 'animated' checkbox doesn't work because the location of objects returns to starting positions not continuing as documented.
Scale visually affects objects, but RigidBody doesn't update.

Event Timeline

Philipp Oeser (lichtwerk) lowered the priority of this task from 90 to 30.May 20 2019, 1:12 PM

Could you share the file demonstrating the issue?

The following is what I did to create the scene:

  • Add floor, set rigid body to passive.
  • Add cube, lift off ground so it will fall, give it a default active rigid body.
  • Duplicate cube several times and arrange so that they will stack on top of each other.
  • Let the simulation play.
  • Select objects that are at the bottom of the stack.
  • Move forward on the timeline and insert keyframe > scaling.
  • Move forward 1 frame.
  • Set scale (individual origins) to 0.
  • Insert keyframe.
  • Now these objects have become disconnected from the physics and their starting position/rotation is now set to the values of where the keyframes were set.

You get random issues now. Sometimes a cube will explode, fall through floor, might scale down if lucky, moving their transforms at any point in timeline could work as if it isn't Active/Dynamic rigidbody.

Brecht Van Lommel (brecht) raised the priority of this task from 30 to 90.May 22 2019, 9:25 PM
Sebastian Parborg (zeddb) lowered the priority of this task from 90 to 50.

@Sergej Reich (sergof) if seems like the bodies are deactivated (even if the option is not used).
So when the scale changes, the rigid bodies needs to be nudged to have them react to the new collision boxes.

Richard Antalik (ISS) changed the task status from Confirmed to Needs Information from User.Feb 2 2020, 10:37 PM

I have re-triaged this report and can not reproduce it (as described in report).
Can you please check if this is still an issue in latest build?
https://builder.blender.org/download/

Richard Antalik (ISS) closed this task as Resolved.Feb 10 2020, 2:23 PM
Richard Antalik (ISS) claimed this task.
Richard Antalik (ISS) edited projects, added Physics; removed Tracker Curfew.

@Sergej Reich (sergof) if seems like the bodies are deactivated (even if the option is not used).
So when the scale changes, the rigid bodies needs to be nudged to have them react to the new collision boxes.

This issue seem to dissapear if I set animated checkbox on "bottom cubes" just before making cubes dissapear by scaling. In this case rigid bodies are in fact animated.